#!/bin/bash

# updated by WIPAT 2555-02-02

MYFILE="/tmp/get-speed-eth0.txt"
DEVFILE="/proc/net/dev"
NETDEV="eth0"

if [ ! -f "${MYFILE}" ] ; then
  NOW=$(date "+%s")
  DATA=$(grep -i "${NETDEV}" ${DEVFILE}|cut -d':' -f 2)
  IN=$(echo ${DATA}|awk '{print $1}')
  OUT=$(echo ${DATA}|awk '{print $9}')
  START="${NOW}:${IN}:${OUT}"
  echo "${START}" > ${MYFILE}
  sleep 5
fi
TEMP=$(head -1 ${MYFILE})
NOW=$(echo ${TEMP}|cut -d':' -f 1)
IN=$(echo ${TEMP}|cut -d':' -f 2)
OUT=$(echo ${TEMP}|cut -d':' -f 3)
START="${NOW}:${IN}:${OUT}"

NOW2=$(date "+%s")
DATA2=$(grep -i "${NETDEV}" ${DEVFILE}|cut -d':' -f 2)
IN2=$(echo ${DATA2}|awk '{print $1}')
OUT2=$(echo ${DATA2}|awk '{print $9}')
STOP="${NOW2}:${IN2}:${OUT2}"
echo "${STOP}" > ${MYFILE}

PERIOD=$(echo "${NOW2:-0} - ${NOW:-0}"|bc)
RIN=$(echo "${IN2:-0} - ${IN:-0}"|bc)
TOUT=$(echo "${OUT2:-0} - ${OUT:-0}"|bc)
SPEEDIN=$(echo "(${RIN:-0} * 8 ) / ${PERIOD:-0}"|bc)
SPEEDOUT=$(echo "(${TOUT:-0} * 8 ) / ${PERIOD:-0}"|bc)
TIME=$(uptime)
echo "${SPEEDIN}"
echo "${SPEEDOUT}"
echo "${TIME}"
echo "MYHOST"
